package com.romhay.chatter_sms

import androidx.annotation.NonNull
import io.flutter.plugin.common.JSONMethodCodec
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.PluginRegistry.Registrar
import io.flutter.plugin.common.StandardMethodCodec

/** ChatterSmsPlugin */
class ChatterSmsPlugin: MethodChannel.MethodCallHandler {

  companion object{
    private val querySMS = "chatter.romhay.app/querySMS"
    private val queryContact = "chatter.romhay.app/queryContact"
    private val queryContactPhoto = "chatter.romhay.app/queryContactPhoto"
    private val queryUserProfile = "chatter.romhay.app/userProfile"

    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "chatter_sms")
      channel.setMethodCallHandler(ChatterSmsPlugin())

      val querySmsChannel = MethodChannel(registrar.messenger(), querySMS, JSONMethodCodec.INSTANCE)
      querySmsChannel.setMethodCallHandler(SMSQuery(registrar))

      val queryContactChannel = MethodChannel(registrar.messenger(), queryContact, JSONMethodCodec.INSTANCE)
      queryContactChannel.setMethodCallHandler(ContactQuery(registrar))

      val queryContactPhotoChannel = MethodChannel(registrar.messenger(), queryContactPhoto, StandardMethodCodec.INSTANCE)
      queryContactPhotoChannel.setMethodCallHandler(ContactPhotoQuery(registrar))

      val userProfileProviderChannel = MethodChannel(registrar.messenger(), queryUserProfile, JSONMethodCodec.INSTANCE)
      userProfileProviderChannel.setMethodCallHandler(UserProfileProvider(registrar))
    }
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: MethodChannel.Result) {
    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    } else {
      result.notImplemented()
    }
  }
}